/* 

   libj - libjcmd.h              Copyright (C) 2001-1998 Justin David Smith    
   justins@chaos2.org            http://chaos2.org/
    
   Header for jcmd library


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#ifndef __libj_cmd_included
#define __libj_cmd_included


#include <libj.h>
#include <libjfile.h>


typedef int (*cmdfunc)(file *f, const char *name, const char *arg, int code, void *cmddata, void *data);


typedef struct _cmd {
   const char *name;
   int         code;
   cmdfunc     func;
   void       *data;
} cmd;


cmd *cmd_search(cmd *c, const char *name);
int cmd_parse_file(cmd *c, const char *filename, void *data);


#endif
