/* 

   libj - jmath.h                Copyright (C) 2001-1998 Justin David Smith
   justins@chaos2.org            http://chaos2.org/
    
   Header for miscellaneous math functions


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#ifndef __libj_math_included
#define __libj_math_included


#include <libj.h>


typedef struct _prstate {
   qword pr_i;
   qword pr_k;
   qword pr_n;
   qword pr_x;
   qword pr_y;
   qword **pr_r;
   qword pr_rcount;
} prstate;


qword gcd(qword a, qword b);
qword mod_exponent(qword a, qword b, qword n);
bool pseudo_prime(qword n);
bool mr_prime(qword n, qword trials);
qword pr_factor(prstate *pr, qword n, qword **r, qword runtime);
bool pr_verify(prstate *pr);
qword pr_resume(prstate *pr, qword runtime);


#endif
