/* $Header: /fridge/cvs/libj/jstr/str_info.c,v 1.3 2001/12/10 19:39:30 justins Exp $ */                                                                                                    
/* 

   libj - str_info.c             Copyright (C) 2001-1998 Justin David Smith    
   justins (a) chaos2.org        http://chaos2.org/
    
   Miscellaneous information about the string


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#define  ALLOW_LIBC_STRING    1
#include <libjstr.h>
#include <_str.h>



sizea strlenn(const char *s) {
/* String-Length-Nullsafe
   Returns the string length, except if <s> = NULL, in which case 0 is 
   returned. */

   return(STRLENN(s));

}



sizea strnlenn(const char *src, sizea maxlen) {
/* strnlenn 
   Returns the length of the string, never scanning beyond maxlen 
   characters of the string.  */

   const char *p = src;
   if(src == NULL || maxlen <= 0) return(0);
   while(maxlen > 0 && *p != '\0') {
      ++p;
      --maxlen;
   }
   return(p - src);

}



sizea strnumwords(const char *s) {
/* String-Number-of-Words */

   bool inword = false;
   sizea numwords = 0;

   if(s != NULL) {
      while(*s != '\0') {
         if(WHITESPACE(*s)) inword = false;
         else if(!inword) {
            ++numwords;
            inword = true;
         }
         ++s;
      }
   }
   return(numwords);
   
}



sizea strnumlines(const char *s) {
/* String-Number-of-Lines */

   sizea lines = 0;

   if(s != NULL && *s != '\0') {
      ++lines;
      while(*s != '\0') {
         if(*s == '\n') ++lines;
         ++s;
      }
   }
   return(lines);

}
