/* $Header: /fridge/cvs/libj/jstra/stra_arg.c,v 1.3 2001/12/10 19:44:08 justins Exp $ */                                                                                                    
/* 

   libj - stra_arg.c             Copyright (C) 2001-1998 Justin David Smith
   justins (a) chaos2.org        http://chaos2.org/
    
   Argument processing


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#define  ALLOW_LIBC_STRING    1
#include <libjstra.h>
#include <_str.h>



#define  __need_newminsizea   1
#define  __need_setlena       1
#define  __need_freea         1
#include <_stra_alloc.h>



stringa *getarga(stringa *d, const char *s, sizea argnum, char sep) {
/* Get-Argument-A
   This function provides a StringA interface to the GetArg* 
   commands by providing a temporary, internal buffer which is
   sized to the string length of <s>. This really should be
   rewritten to incorporate the code in getarg and in strcpya 
   directly. */

   if(d != NULL) {
      /* Make sure source string is defined */
      if(s != NULL) {

         /* Allocate the temp buffer */
         __strnewminsizea(d, STRLENN(s) + 1);

         /* Call the getarg() functions, copy the buffer string */
         getarg(d->string, s, argnum, sep);
         __strsetlena(d);
         
      } else {
      
         /* Release */
         __strfreea(d);
      
      }
   }
   return(d);

}


stringa *getargaa(stringa *d, const stringa *s, sizea argnum, char sep) {
/* Get-Argument-A-To-A
   This function provides a StringA interface to the GetArg* 
   commands by providing a temporary, internal buffer which is
   sized to the string length of <s>. This really should be
   rewritten to incorporate the code in getarg and in strcpya 
   directly. */

   if(d != NULL) {
      /* Make sure source string is defined */
      if(s != NULL && s->string != NULL) {
   
         /* Allocate the new string buffer */
         __strnewminsizea(d, s->length);

         /* Call the getarg() functions, copy the buffer string */
         getarg(d->string, s->string, argnum, sep);
         __strsetlena(d);

      } else { 
      
         /* Release old target buffer only */
         __strfreea(d);
         
      }
   }
   return(d);

}


