/* $Header: /fridge/cvs/libj/jstra/stra_cgi.c,v 1.3 2001/12/10 19:44:08 justins Exp $ */                                                                                                    
/* 

   libj - stra_cgi.c             Copyright (C) 2001-1998 Justin David Smith
   justins (a) chaos2.org        http://chaos2.org/
    
   StringA implementation of certain CGI calls


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#define  ALLOW_LIBC_STRING    1
#include <libjstra.h>
#include <_str.h>


#define  __need_newminsizea   1
#define  __need_setlena       1
#define  __need_freea         1
#include <_stra_alloc.h>



bool getassigna(stringa *var, stringa *val, const char *s) {
/* Get-Assignment-A
   This is a StringA interface to the GetAssign function. */

   bool result = false;
   sizea slen;

   if(var != NULL && val != NULL) {
      if(s != NULL) {
         slen = STRLEN(s) + 1;

         /* Allocate temp buffers. */
         __strnewminsizea(var, slen);
         __strnewminsizea(val, slen);
      
         result = getassignbb(var->string, val->string, s, slen, slen);
         if(!result) {
            if(var->string != NULL) *var->string = '\0';
            if(val->string != NULL) *val->string = '\0';
         }
      
         __strsetlena(var);
         __strsetlena(val);
      } else { 
         __strfreea(var);
         __strfreea(val);
      }
   }
   
   return(result);
   
}



bool getassignaa(stringa *var, stringa *val, const stringa *s) {
/* Get-Assignment-AA
   This is a StringA interface to the GetAssign function. */

   bool result = false;
   sizea slen;

   if(var != NULL && val != NULL) {
      if(s != NULL && s->string != NULL) {
         slen = s->length;

         /* Allocate temp buffers. */
         __strnewminsizea(var, slen);
         __strnewminsizea(val, slen);
      
         result = getassignbb(var->string, val->string, s->string, slen, slen);
         if(!result) {
            if(var->string != NULL) *var->string = '\0';
            if(val->string != NULL) *val->string = '\0';
         }
      
         __strsetlena(var);
         __strsetlena(val);
      } else { 
         __strfreea(var);
         __strfreea(val);
      }
   }
   
   return(result);
   
}



