/* $Header: /fridge/cvs/libj/jstra/stra_comp.c,v 1.3 2001/12/10 19:44:08 justins Exp $ */                                                                                                    
/* 

   libj - stra_comp.c            Copyright (C) 2001-1998 Justin David Smith
   justins (a) chaos2.org        http://chaos2.org/
    
   StringA comparison -- checks lengths before attempting a full compare


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#define  ALLOW_LIBC_STRING    1
#include <libjstra.h>
#include <_str.h>



bool strequalaa(const stringa *a, const stringa *b) {

   if(stra(a) != NULL && stra(b) != NULL) {
      if(a->length == b->length) return(STREQL(a->string, b->string));
      return(false);
   }
   return(stra(a) == NULL && stra(b) == NULL);

}



bool strequalnaa(const stringa *a, const stringa *b, sizea n) {

   if(stra(a) != NULL && stra(b) != NULL) {
      if(min(a->length, n) == min(b->length, n)) return(STRNEQL(a->string, b->string, n));
      return(false);
   }
   return(stra(a) == NULL && stra(b) == NULL);

}



