/* $Header: /fridge/cvs/libj/jstra/stra_creat.c,v 1.3 2001/12/10 19:44:08 justins Exp $ */                                                                                                    
/* 

   libj - stra_creat.c           Copyright (C) 2001-1998 Justin David Smith
   justins (a) chaos2.org        http://chaos2.org/
    
   StringA creation and destruction


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#define  ALLOW_LIBC_STRING    1
#include <libjstra.h>
#include <_str.h>



#define  __need_newminsizea   1
#define  __need_cpya          1
#define  __need_cpyaa         1
#define  __need_freea         1
#include <_stra_alloc.h>



stringa *strnewa(const char *s) {
/* String-New-A */

   stringa *a;

   a = (stringa *)malloc(sizeof(stringa));
   if(a != NULL) {
      a->string = NULL;
      a->length = 0;
      a->bufsize = 0;
      if(s == NULL) {
         __strcpya(a, "");
      } else {
         __strcpya(a, s);
      }
   }
   return(a);
   
}



stringa *strclonea(const stringa *s) {
/* String-Clone-A */

   stringa *a;
   
   a = (stringa *)malloc(sizeof(stringa));
   if(a != NULL) __strcpyaa(a, s);
   return(a);
   
}



void strfreea(stringa *a) {
/* String-Free-A */

   if(a != NULL) __strfreea(a);

}



void strreleasea(stringa **a) {
/* String-Release-A */

   if(a != NULL && *a != NULL) {
      __strfreea(*a);
      free(*a);
      *a = NULL;
   }

}



void strcollapsea(stringa **a) {
/* String-Collapse-A */

   if(a != NULL) {
      free(*a);
      *a = NULL;
   }

}



