/* $Header: /fridge/cvs/libj/jstra/stra_io.c,v 1.3 2001/12/10 19:44:08 justins Exp $ */                                                                                                    
/* 

   libj - stra_io.c              Copyright (C) 2001-1998 Justin David Smith
   justins (a) chaos2.org        http://chaos2.org/
    
   File IO with stringa's


   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this library; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
   
   This file is part of LIBJ.
   
*/
#define  ALLOW_LIBC_STRING    1
#include <libjstra.h>
#include <_str.h>



bool freada(stringa *d, FILE *f) {
/* File-Read-A
   Reads a standard text line from the specified file and writes it into a
   StringA-style string, using strcpya and strcata. This function is useful
   for reading lines from files when you do not know the final length of the
   line. Returns the status flag of the (last) fgets call; basically, returns
   true if the fgets calls are successful and false on an EOF. There will be
   a trailing newline on this string, in all likelihood. */
   
   char *buf;
   
   if(d != NULL && f != NULL) {
      buf = (char *)malloc(READBUF);
      if(buf != NULL) {

         /* Get the buffer */
         if(fgets(buf, READBUF, f) != NULL) {
            strcopya(d, buf);
            while(*(buf + STRLEN(buf) - 1) != '\n' && fgets(buf, READBUF, f) != NULL) {
      
               /* Damn. There's either more to append to this string or possibly we
                  have reached the end of the file but there was no final lf. Hmmm.. */
               strconcata(d, buf);
            }
         } else {
            free(buf);
            return(false);
         }
         
         free(buf);
         return(true);
      }
   }
   return(false);

}

