/* LIBTOKEN                                                 Version 0.1.2
   Copyright (C) 1998   Justin Smith             justins@ugcs.caltech.edu
   ----------------------------------------------------------------------

   This  program  is free software; you can redistribute it and/or modify
   it  under  the terms of the GNU General Public License as published by
   the  Free  Software  Foundation;  either  version 2 of the License, or   
   (at your option) any later version.

   This  program  is  distributed  in  the  hope  that it will be useful,
   but  WITHOUT  ANY  WARRANTY;  without  even  the  implied  warranty of 
   MERCHANTABILITY   or  FITNESS  FOR  A  PARTICULAR  PURPOSE.   See  the  
   GNU General Public License for more details.

   You  should  have  received  a  copy of the GNU General Public License
   along  with  this  program,  in the file COPYING. If not, write to the
   Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA

   ----------------------------------------------------------------------
*/


#ifdef   __LIBTOKEN_SOURCE
#ifndef  __LIBTOKEN__SUPP__HH__
#define  __LIBTOKEN__SUPP__HH__


/*** Support Functions ***/


int printFileError(const tokeniser *t);
tokencmd *cmdExists(tokeniser *t, const char *cmdname);
bool cmdIgnoreIfBlocks(const tokencmd *c);
bool cmdDoNotExecArgs(const tokencmd *c);
bool cmdIsCustom(const tokencmd *c);
bool ifExec(const tokeniser *t);
bool ifCmdExec(const tokeniser *t, const tokencmd *c);
tokenvar *varExists(tokeniser *t, const char *varname);
bool intVar(tokenvar *v);
void tokenCommandValidate(char *d, const char *s);
void tokenDestroyCommand(void *data);
void tokenVariableValidate(char *d, const char *s);
void tokenDestroyVariable(void *data);
void tokenSaveState(tokensavedstate *ss, tokeniser *t);
void tokenRestoreState(tokeniser *t, tokensavedstate *ss);

#ifndef NO_MATH_LIB
void mathWriteNumber(file *fo, double n);
#endif // math lib?


#endif   // header include
#endif   // libtoken source