/* $Header: /fridge/cvs/libj/libj.h.in,v 1.3 2001/12/10 20:24:44 justins Exp $ */
/* 

   libj - libj.h                 Copyright (C) 2001-1998 Justin David Smith
   justins (a) chaos2.org        http://chaos2.org/
    
   Definitions for libj
   

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program, in the file COPYING. If not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
   
   
   This file is part of LIBJ.
   
*/


/* For libj 4.0.3 */


#ifndef __libj_included
#define __libj_included


/* Include files */
#include <stdlib.h>


/* Version information */
#define  __libj_version       ((((long)4 & 0xff) << 24) | (((long)0 & 0xff) << 16) | (((long)3 & 0xff) << 8)) /* Version 4.0.3 */


/* Compilation definitions */
#define  X86_ASM              0
#define  LVALUE_STRICT        0
#define  LIBC_STRING          1
#define  TIME_WITH_SYS_TIME   1
#define  HAVE_SYS_TIME_H      1
#define  HAVE_GETTIMEOFDAY    1


/* Miscellaneous constants */
#define  RK_PRIME          32749 /* Rabin-karp prime number (should be 15-bits max) */
#define  MAXLEN            0x1000/* Default maximum string length */
#define  READBUF           0x4000/* Default read buffer size */


/* Data types */
typedef  unsigned char    ubyte;
typedef  unsigned short    uword;
typedef  unsigned int   udword;
typedef  unsigned long long   uqword;

typedef  signed char      sbyte;
typedef  signed short      sword;
typedef  signed int     sdword;
typedef  signed long long     sqword;

typedef  unsigned char    byte;
typedef  unsigned short    word;
typedef  unsigned int   dword;
typedef  unsigned long long   qword;
typedef  unsigned int   sizea;
typedef  signed int     indexa;
typedef  unsigned short    wchar;
typedef  signed int     dimensiona;


/* Other useful definitions */
#define  false                   0
#define  true                    (!false)
#ifndef __cplusplus
typedef  ubyte                   bool;
#endif /* not C++ */


/* Useful in manipulating ranges of numbers */
#define  clamp(x, a, b)          ((x) < (a) ? (a) : (x) > (b) ? (b) : (x))
#define  min(x, a)               ((x) < (a) ? (x) : (a))
#define  max(x, a)               ((x) > (a) ? (x) : (a))


/* Typical function defines */
typedef  void (*destructorfn)(void *data);
typedef  bool (*comparefn)(const void *a, const void *b);
typedef  bool (*iteratorfn)(void *a, void *params);


/* Version method */
unsigned int libj_version(void);


#endif /* Header included? */

